module user.doob_test1.MouseHandler;

private import dwt.events.MouseListener;
private import dwt.events.MouseMoveListener;
private import dwt.events.MouseEvent;

private import tango.io.Stdout;

private import user.doob_test1.PaintHandler;

class MouseHandler : MouseListener, MouseMoveListener {
    PaintHandler hPaint;
    bool pressed = false;

    this(PaintHandler ph) {
        hPaint = ph;
    }

    void mouseDoubleClick(MouseEvent e) {
    }

    void mouseDown(MouseEvent e) {
        hPaint.x = e.x;
        hPaint.y = e.y;
        pressed = true;
    }

    void mouseUp(MouseEvent e) {
        hPaint.xDiff = e.x-hPaint.x;
        hPaint.yDiff = e.y-hPaint.y;
        hPaint.reDraw();
        pressed = false;
    }

    void mouseMove(MouseEvent e) {
        if(pressed) {
            hPaint.xDiff = e.x-hPaint.x;
            hPaint.yDiff = e.y-hPaint.y;
            hPaint.reDraw();
        }
    }
}